<?php
/**
 * @package     BreezingForms
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// TODO: uninstall routine

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if(!defined('DS')){
    define('DS', DIRECTORY_SEPARATOR);
}

require_once JPATH_SITE . DS . 'plugins' . DS . 'breezingforms_addons' . DS . 'skype' . DS . 'breezingforms_addons_skype_libraries' . DS . 'autoload.php';

use Skype\Client;

jimport( 'joomla.plugin.plugin' );
jimport('joomla.version');
               
class plgBreezingforms_addonsSkype extends JPlugin
{
    
    function __construct( &$subject, $params )
    {
        parent::__construct($subject, $params);
    
        $lang = JFactory::getLanguage();
        $lang->load('plg_breezingforms_addons_skype', JPATH_ADMINISTRATOR);
        
        $db = JFactory::getDBO();
        
        $tables = $db->getTableList();
        
        if( !in_array( $db->getPrefix().'breezingforms_addons_skype', $tables ) ){
            $db->setQuery("CREATE TABLE `#__breezingforms_addons_skype` (
                `id` int(11) NOT NULL,
                `form_id` int(11) NOT NULL DEFAULT '0',
                `apikey` varchar(255) NOT NULL DEFAULT '',
                `enabled` tinyint(1) NOT NULL DEFAULT '0',
                `password` varchar(255) NOT NULL,
                `head_data` tinyint(1) NOT NULL DEFAULT '0',
                `exclude_fields` text NOT NULL,
                `attach_pdf` tinyint(1) NOT NULL DEFAULT '0',
                `attach_csv` tinyint(1) NOT NULL DEFAULT '0',
                `attach_xml` tinyint(1) NOT NULL DEFAULT '0',
                `tested` tinyint(1) NOT NULL DEFAULT '0',
                `recipients`  text
              ) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8");
            $db->execute();
            
            $db->setQuery("ALTER TABLE `#__breezingforms_addons_skype`
              ADD PRIMARY KEY (`id`),
              ADD UNIQUE KEY `form_id_2` (`form_id`)");
            $db->execute();
            
            $db->setQuery("ALTER TABLE `#__breezingforms_addons_skype`
                MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1");
            $db->execute();
        }
        
        
        jimport('joomla.filesystem.file');
	    jimport('joomla.filesystem.folder');
    }
    
    function onPropertiesDisplay($form_id, $tabs){
        
        if(!$form_id) return '';
        
        $error = '';
        
        $db = JFactory::getDBO();
        
        $db->setQuery("Select * From #__breezingforms_addons_skype Where form_id = " . intval($form_id));
        $tg = $db->loadObject();
        
        $me = array();
        
        if( $tg === null ){
            $tg = new stdClass();
            $tg->id = 0;
            $tg->form_id = 0;
            $tg->head_data = 0;
            $tg->apikey = '';
            $tg->enabled = 0;
            $tg->password = '';
            $tg->exclude_fields = '';
            $tg->attach_pdf = 0;
            $tg->attach_csv = 0;
            $tg->attach_xml = 0;
	        $tg->recipients = '';

        }else{

	        $db->setQuery( "Select tested From #__breezingforms_addons_skype Where form_id = " . intval( $form_id ) );
	        $tested = $db->loadResult();

	        if(!$tested) {

		        // first test, needed to make sure guzzle wrote the access token and things can be sent

		        $recipients = explode( "\n", str_replace( "\r", "", $tg->recipients ) );

		        if ( count( $recipients ) > 0 && trim( $recipients[0] ) != '' ) {

			        // write the keepalive
			        $client = new Client( [
				        'clientId'     => $tg->apikey,
				        'clientSecret' => $tg->password
			        ] );

			        $api = $client->authorize()->api( 'conversation' );   // Skype\Api\Conversation

			        $pfx = '8:';

			        if ( bf_startsWith( $recipients[0], '19:' ) ) {

				        $pfx = '';
			        }

			        $api->activity( $pfx . $recipients[0], '(skype) Bot is active' );

			        $db->setQuery( "Update #__breezingforms_addons_skype Set
	                `tested`  = 1
	                 Where form_id = " . intval( $form_id ) . "
	                " );
			        $db->execute();
		        }
	        }
        }
        
        $auth_url = 'https://dev.botframework.com/';

        ob_start();
        $version = new JVersion();
        require_once JPATH_SITE . DS . 'plugins' . DS . 'breezingforms_addons' . DS . 'skype' . DS . 'breezingforms_addons_skype_tmpl' . DS . 'properties.php';
	    $c = ob_get_contents();
        ob_end_clean();
        return $c;

    }
    
    function onPropertiesSave($form_id){
        
        if(!$form_id) return '';
        
        $accessToken = '';
        $reset_accessToken = false;
        
        if(isset($_POST['skype_apikey']) && $_POST['skype_apikey'] != ''){
            
            $accessToken = $_POST['skype_apikey'];
        }
        
        if(isset($_POST['skype_reset'])){
            $reset_accessToken = true;
            $accessToken = '';
            
        }
        
        $db = JFactory::getDBO();

	    if( $reset_accessToken ){


		    $db->setQuery("Delete From #__breezingforms_addons_skype Where form_id = " . intval($form_id));
		    $db->execute();
	    }
	    else {

		    $db->setQuery( "Select form_id From #__breezingforms_addons_skype Where form_id = " . intval( $form_id ) );
		    $exists = $db->loadResult();

		    if ( ! $exists ) {
			    $db->setQuery( "Insert Into #__breezingforms_addons_skype (
                `form_id`, `enabled`,`head_data`,`exclude_fields`,`attach_pdf`,`attach_csv`,`attach_xml`,`recipients`,`password`, `apikey` ) Values 
                (   " . intval( $form_id ) . ",
                    " . JRequest::getInt( 'skype_enabled', 0 ) . ",
                    " . JRequest::getInt( 'skype_head_data', 0 ) . ",
                    " . $db->quote( JRequest::getVar( 'skype_exclude_fields', '' ) ) . ",
                    " . JRequest::getInt( 'skype_attach_pdf', 0 ) . ",
                    " . JRequest::getInt( 'skype_attach_csv', 0 ) . ",
                    " . JRequest::getInt( 'skype_attach_xml', 0 ) . ",
                    " . $db->quote( JRequest::getVar( 'skype_recipients', '' ) ) . ",
                    " . $db->quote( JRequest::getVar( 'skype_password', '' ) ) . ",
                    " . ( $accessToken ? $db->quote( $accessToken ) : '""' ) . "
                )" );
			    $db->execute();
		    } else {
			    $db->setQuery( "Update #__breezingforms_addons_skype Set
                `enabled`  = " . JRequest::getInt( 'skype_enabled', 0 ) . ",
                `head_data`  = " . JRequest::getInt( 'skype_head_data', 0 ) . ",
                `attach_pdf`  = " . JRequest::getInt( 'skype_attach_pdf', 0 ) . ",
                `attach_csv`  = " . JRequest::getInt( 'skype_attach_csv', 0 ) . ",
                `attach_xml`  = " . JRequest::getInt( 'skype_attach_xml', 0 ) . ",
                `recipients`  = " . $db->quote( JRequest::getVar( 'skype_recipients', '' ) ) . ",
                `exclude_fields`  = " . $db->quote( JRequest::getVar( 'skype_exclude_fields', '' ) ) . "
                " . ( $accessToken ? ",`apikey` = " . $db->quote( $accessToken ) : '' ) . "
                 Where form_id = " . intval( $form_id ) . "
            " );
			    $db->execute();
		    }
	    }
    }
    
    function onPropertiesExecute($processor){
        
        if(!$processor->form) return;
        
        $db = JFactory::getDBO();
        
        $db->setQuery("Select * From #__breezingforms_addons_skype Where form_id = " . intval($processor->form));
        $tg = $db->loadObject();
        
        if( $tg === null ){
            $tg = new stdClass();
            $tg->id = 0;
            $tg->form_id = 0;
            $tg->head_data = 0;
            $tg->apikey = '';
            $tg->enabled = 0;
            $tg->password = '';
            $tg->exclude_fields = '';
            $tg->attach_pdf = 0;
            $tg->attach_csv = 0;
            $tg->attach_xml = 0;
	        $tg->recipients = '';
        }
        
        if( $tg->enabled == 1 ){
            
            try{
            
                jimport('joomla.version');
                $version = new JVersion();
                $_version = $version->getShortVersion();
                $tz = 'UTC';
                if(version_compare($_version, '3.2', '>=')){
                    $tz = new DateTimeZone(JFactory::getApplication()->getCfg('offset'));
                }

                $submitted = $processor->submitted;
                if(version_compare($_version, '3.2', '>=')){
                    $date_ = JFactory::getDate($processor->submitted, $tz);
                    $offset = $date_->getOffsetFromGMT();
                    if($offset > 0){
                        $date_->add(new DateInterval('PT'.$offset.'S'));
                    }else if($offset < 0){
                        $offset = $offset*-1;
                        $date_->sub(new DateInterval('PT'.$offset.'S'));
                    }

                    $submitted = $date_->format('Y-m-d H:i:s', true);
                }
                
                $head = '';
                
                if( $tg->head_data == 1 ){

                    $head = 
                    BFText::_('COM_BREEZINGFORMS_PROCESS_FORMID') . ": " . $processor->form . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_FORMTITLE') . ": " . $processor->formrow->title . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_FORMNAME') . ": " . $processor->formrow->name . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTEDAT') . ": " . $submitted . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTERIP') . ": " . $processor->ip . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTERID') . ": " . JFactory::getUser()->get('id', 'Not logged in') . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTERUSERNAME') . ": " . JFactory::getUser()->get('username', 'Not logged in') . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTERFULLNAME') . ": " . JFactory::getUser()->get('name', 'Not logged in') . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_PROVIDER') . ": " . $processor->provider . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_BROWSER') . ": " . $processor->browser . "\r\n" .
                    BFText::_('COM_BREEZINGFORMS_PROCESS_OPSYS') . ": " . $processor->opsys . "\r\n\r\n";
                
                }

                $uploads = array();
                $msg = '';

                $filter = explode("\n", str_replace("\r","",$tg->exclude_fields));

                foreach($processor->savedata As $data){

                	if (!in_array($data[_FF_DATA_NAME], $filter)) {

                		$val = $data[_FF_DATA_VALUE];

		                if($data[_FF_DATA_TYPE] == 'File Upload'){

			                $val = basename($val);
		                }

                        $msg .= strip_tags($data[_FF_DATA_TITLE]).': '.strip_tags(str_replace('<br />',"\r\n",$val))."\r\n";
		                $msg .= "\r\n";
                    }

                    if (!in_array($data[_FF_DATA_NAME], $filter) && $data[_FF_DATA_TYPE] == 'File Upload') {

                        $the_files = explode("\n", $data[_FF_DATA_VALUE]);

                        foreach($the_files As $the_file){
                            if(trim($the_file) != ''){
                                $uploads[] = $the_file;
                            }
                        }
                    }
                    else if (!in_array($data[_FF_DATA_NAME], $filter) && $data[_FF_DATA_TYPE] == 'Signature') {

	                    $the_file = JPATH_SITE . '/media/breezingforms/signatures/' . basename($data[_FF_DATA_VALUE]);

	                    if(JFile::exists($the_file)){

		                    $uploads[] = $the_file;
	                    }
                    }
                }

	            $client = new Client([
		            'clientId' => $tg->apikey,
		            'clientSecret' => $tg->password
	            ]);

	            $api = $client->authorize()->api('conversation');   // Skype\Api\Conversation

				$recipients = explode("\n", str_replace("\r","",$tg->recipients));

				if( count($recipients) == 0 || trim($recipients[0]) == '' ){
					throw new Exception();
				}

	            $skype_folder = JPATH_SITE . '/media/breezingforms/plugins/skype/' . uniqid() . '/';

				if(!JFolder::exists($skype_folder)) {

					JFolder::create( $skype_folder );
				}

				$new_uploads = array();

	            foreach ( $uploads As $upload ) {

	            	JFile::copy($upload, $skype_folder.basename($upload));

		            $new_uploads[] = $skype_folder . basename($upload);
	            }

				foreach($recipients As $recipient) {

					if(trim($recipient) == ''){

						continue;
					}

					$pfx = '8:';

					if( bf_startsWith($recipient, '19:') ){

						$pfx = '';
					}

					$the_msg = '(skype) ' . BFText::_('COM_BREEZINGFORMS_SKYPE_NEW_RECORD')."\r\n\r\n";
					$the_msg .= $head.$msg;

					//$api->activity($pfx.$recipient, '(skype) ' . BFText::_('COM_BREEZINGFORMS_SKYPE_NEW_RECORD')."\r\n\r\n");
					//$api->activity($pfx.$recipient, $head.$msg);

					foreach ( $new_uploads As $upload ) {

						//$api->activity($pfx.$recipient, str_replace(JPATH_SITE, rtrim(JUri::root(),'/') , $upload));
						$the_msg .= str_replace(JPATH_SITE, rtrim(JUri::root(),'/') , $upload)."\r\n\r\n";
					}

					if ( $tg->attach_pdf ) {
						$pdf = $processor->exppdf();
						JFile::copy($pdf, $skype_folder.basename($pdf));
						JFile::delete( $pdf );
						//$api->activity($pfx.$recipient, str_replace(JPATH_SITE, rtrim(JUri::root(),'/') , $skype_folder . basename($pdf)));
						$the_msg .= str_replace(JPATH_SITE, rtrim(JUri::root(),'/') , $skype_folder . basename($pdf))."\r\n\r\n";
					}

					if ( $tg->attach_csv ) {
						$csv = $processor->expcsv();
						JFile::copy($csv, $skype_folder.basename($csv));
						JFile::delete( $csv );
						//$api->activity($pfx.$recipient, str_replace(JPATH_SITE, rtrim(JUri::root(),'/') , $skype_folder . basename($csv)));
						$the_msg .= str_replace(JPATH_SITE, rtrim(JUri::root(),'/') , $skype_folder . basename($csv))."\r\n\r\n";
					}

					if ( $tg->attach_xml ) {
						$xml = $processor->expxml();
						JFile::copy($xml, $skype_folder.basename($xml));
						JFile::delete( $xml );
						//$api->activity($pfx.$recipient, str_replace(JPATH_SITE, rtrim(JUri::root(),'/') , $skype_folder . basename($xml)));
						$the_msg .= str_replace(JPATH_SITE, rtrim(JUri::root(),'/') , $skype_folder . basename($xml))."\r\n\r\n";
					}

					//$api->activity($pfx.$recipient, BFText::_('COM_BREEZINGFORMS_SKYPE_END_RECORD') . ' (bow)');

					$the_msg .= "\r\n\r\n" . BFText::_('COM_BREEZINGFORMS_SKYPE_END_RECORD') . ' (bow)';

					$api->activity($pfx.$recipient, $the_msg);

				}
            
            }catch(Exception $e){
                // nothing, be silent
            }
        }
    }
}
