<?php
/**
 * @package     BreezingForms
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// TODO: uninstall routine

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if(!defined('DS')){
    define('DS', DIRECTORY_SEPARATOR);
}

require_once JPATH_SITE . DS . 'plugins' . DS . 'breezingforms_addons' . DS . 'telegram' . DS . 'breezingforms_addons_telegram_libraries' . DS . 'Telegram.php';
 
jimport( 'joomla.plugin.plugin' );
jimport('joomla.version');
               
class plgBreezingforms_addonsTelegram extends JPlugin
{
    
    function __construct( &$subject, $params )
    {
        parent::__construct($subject, $params);
    
        $lang = JFactory::getLanguage();
        $lang->load('plg_breezingforms_addons_telegram', JPATH_ADMINISTRATOR);
        
        $db = JFactory::getDBO();
        
        $tables = $db->getTableList();
        
        if( !in_array( $db->getPrefix().'breezingforms_addons_telegram', $tables ) ){
            $db->setQuery("CREATE TABLE `#__breezingforms_addons_telegram` (
                `id` int(11) NOT NULL,
                `form_id` int(11) NOT NULL DEFAULT '0',
                `apikey` varchar(255) NOT NULL DEFAULT '',
                `enabled` tinyint(1) NOT NULL DEFAULT '0',
                `password` varchar(255) NOT NULL,
                `head_data` tinyint(1) NOT NULL DEFAULT '0',
                `exclude_fields` text NOT NULL,
                `attach_pdf` tinyint(1) NOT NULL DEFAULT '0',
                `attach_csv` tinyint(1) NOT NULL DEFAULT '0',
                `attach_xml` tinyint(1) NOT NULL DEFAULT '0'
              ) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8");
            $db->query();
            
            $db->setQuery("ALTER TABLE `#__breezingforms_addons_telegram`
              ADD PRIMARY KEY (`id`),
              ADD UNIQUE KEY `form_id_2` (`form_id`)");
            $db->query();
            
            $db->setQuery("ALTER TABLE `#__breezingforms_addons_telegram`
                MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1");
            $db->query();
        }
        
        if( !in_array( $db->getPrefix().'breezingforms_addons_telegram_chats', $tables ) ){
            $db->setQuery("CREATE TABLE `#__breezingforms_addons_telegram_chats` (
                `id` int(11) NOT NULL,
                `form_id` int(11) NOT NULL,
                `chat_id` int(11) NOT NULL
              ) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8");
            $db->query();
            
            $db->setQuery("ALTER TABLE `#__breezingforms_addons_telegram_chats`
            ADD PRIMARY KEY (`id`),
            ADD UNIQUE KEY `form_id` (`form_id`,`chat_id`)");
            $db->query();
            
            $db->setQuery("ALTER TABLE `#__breezingforms_addons_telegram_chats`
            MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1");
            $db->query();
        }
        
        
        jimport('joomla.filesystem.file');
    }
    
    function onPropertiesDisplay($form_id, $tabs){
        
        if(!$form_id) return '';
        
        $error = '';
        
        $db = JFactory::getDBO();
        
        $db->setQuery("Select * From #__breezingforms_addons_telegram Where form_id = " . intval($form_id));
        $tg = $db->loadObject();
        
        $me = array();
        
        if( $tg === null ){
            $tg = new stdClass();
            $tg->id = 0;
            $tg->form_id = 0;
            $tg->head_data = 0;
            $tg->apikey = '';
            $tg->enabled = 0;
            $tg->password = '';
            $tg->exclude_fields = '';
            $tg->attach_pdf = 0;
            $tg->attach_csv = 0;
            $tg->attach_xml = 0;
        }else{
            $telegram = new telegramBot($tg->apikey);
            $me = $telegram->getMe();
        }
        
        $auth_url = 'https://core.telegram.org/bots#botfather';
        
        ob_start();
        $version = new JVersion();
        require_once JPATH_SITE . DS . 'plugins' . DS . 'breezingforms_addons' . DS . 'telegram' . DS . 'breezingforms_addons_telegram_tmpl' . DS . 'properties.php';
        $c = ob_get_contents();
        ob_end_clean();
        return $c;
    }
    
    function onPropertiesSave($form_id){
        
        if(!$form_id) return '';
        
        $accessToken = '';
        $reset_accessToken = false;
        
        if(isset($_POST['telegram_apikey']) && $_POST['telegram_apikey'] != ''){
            
            $accessToken = $_POST['telegram_apikey'];
        }
        
        if(isset($_POST['telegram_reset'])){
            $reset_accessToken = true;
            $accessToken = '';
            
        }
        
        $db = JFactory::getDBO();
        
        $db->setQuery("Select form_id From #__breezingforms_addons_telegram Where form_id = " . intval($form_id));
        $exists = $db->loadResult();
        
        if(!$exists){
            $db->setQuery("Insert Into #__breezingforms_addons_telegram (
                `form_id`, `enabled`,`head_data`,`exclude_fields`,`attach_pdf`,`attach_csv`,`attach_xml`,`password`,`apikey` ) Values 
                (   ".intval($form_id).",
                    ".JRequest::getInt('telegram_enabled', 0).",
                    ".JRequest::getInt('telegram_head_data', 0).",
                    ".$db->quote(JRequest::getVar('telegram_exclude_fields', '')).",
                    ".JRequest::getInt('telegram_attach_pdf', 0).",
                    ".JRequest::getInt('telegram_attach_csv', 0).",
                    ".JRequest::getInt('telegram_attach_xml', 0).",
                    ".$db->quote(JRequest::getVar('telegram_password', '')).",
                    ".($accessToken ? $db->quote($accessToken) : '""')."
                )");
            $db->query();
        } else {
            $db->setQuery("Update #__breezingforms_addons_telegram Set
                `enabled`  = ".JRequest::getInt('telegram_enabled', 0).",
                `head_data`  = ".JRequest::getInt('telegram_head_data', 0).",
                `attach_pdf`  = ".JRequest::getInt('telegram_attach_pdf', 0).",
                `attach_csv`  = ".JRequest::getInt('telegram_attach_csv', 0).",
                `attach_xml`  = ".JRequest::getInt('telegram_attach_xml', 0).",
                `exclude_fields`  = ".$db->quote(JRequest::getVar('telegram_exclude_fields', '')).",
                `password`  = ".$db->quote(JRequest::getVar('telegram_password', ''))."
                ".($accessToken || $reset_accessToken ? ",`apikey` = " . $db->quote($accessToken) : '')."
                 Where form_id = " . intval($form_id) . "
            ");
            $db->query();
        }
    }
    
    function onPropertiesExecute($processor){
        
        if(!$processor->form) return;
        
        $db = JFactory::getDBO();
        
        $db->setQuery("Select * From #__breezingforms_addons_telegram Where form_id = " . intval($processor->form));
        $tg = $db->loadObject();
        
        if( $tg === null ){
            $tg = new stdClass();
            $tg->id = 0;
            $tg->form_id = 0;
            $tg->head_data = 0;
            $tg->apikey = '';
            $tg->enabled = 0;
            $tg->password = '';
            $tg->exclude_fields = '';
            $tg->attach_pdf = 0;
            $tg->attach_csv = 0;
            $tg->attach_xml = 0;
        }
        
        if( $tg->enabled == 1 ){
            
            try{
            
                jimport('joomla.version');
                $version = new JVersion();
                $_version = $version->getShortVersion();
                $tz = 'UTC';
                if(version_compare($_version, '3.2', '>=')){
                    $tz = new DateTimeZone(JFactory::getApplication()->getCfg('offset'));
                }

                $submitted = $processor->submitted;
                if(version_compare($_version, '3.2', '>=')){
                    $date_ = JFactory::getDate($processor->submitted, $tz);
                    $offset = $date_->getOffsetFromGMT();
                    if($offset > 0){
                        $date_->add(new DateInterval('PT'.$offset.'S'));
                    }else if($offset < 0){
                        $offset = $offset*-1;
                        $date_->sub(new DateInterval('PT'.$offset.'S'));
                    }

                    $submitted = $date_->format('Y-m-d H:i:s', true);
                }
                
                $head = '';
                
                if( $tg->head_data == 1 ){

                    $head = 
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_FORMID') . ": " . $processor->form . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_FORMTITLE') . ": " . $processor->formrow->title . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_FORMNAME') . ": " . $processor->formrow->name . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTEDAT') . ": " . $submitted . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTERIP') . ": " . $processor->ip . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTERID') . ": " . JFactory::getUser()->get('id', 'Not logged in') . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTERUSERNAME') . ": " . JFactory::getUser()->get('username', 'Not logged in') . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_SUBMITTERFULLNAME') . ": " . JFactory::getUser()->get('name', 'Not logged in') . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_PROVIDER') . ": " . $processor->provider . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_BROWSER') . ": " . $processor->browser . "\r\n" .
                    "\xE2\x84\xB9 ". BFText::_('COM_BREEZINGFORMS_PROCESS_OPSYS') . ": " . $processor->opsys . "\r\n\r\n";
                
                }

                $uploads = array();
                $msg = '';

                $filter = explode("\n", str_replace("\r","",$tg->exclude_fields));

                foreach($processor->savedata As $data){
                    if (!in_array($data[_FF_DATA_NAME], $filter) && $data[_FF_DATA_TYPE] != 'File Upload') {
                        $msg .= "\xE2\x9C\x8F ".strip_tags($data[_FF_DATA_TITLE]).': '.strip_tags(str_replace('<br />',"\r\n",$data[_FF_DATA_VALUE]))."\r\n";
                    }
                    else if (!in_array($data[_FF_DATA_NAME], $filter) && $data[_FF_DATA_TYPE] == 'File Upload') {

                        $the_files = explode("\n", $data[_FF_DATA_VALUE]);

                        foreach($the_files As $the_file){
                            if(trim($the_file) != ''){
                                $uploads[] = $the_file;
                            }
                        }
                    }
                    else if (!in_array($data[_FF_DATA_NAME], $filter) && $data[_FF_DATA_TYPE] == 'Signature') {

	                    $the_file = JPATH_SITE . '/media/breezingforms/signatures/' . basename($data[_FF_DATA_VALUE]);

	                    if(JFile::exists($the_file)){

		                    $uploads[] = $the_file;
	                    }
                    }
                }

                $telegram = new telegramBot($tg->apikey);
                $updates = $telegram->pollUpdates();

;
                $send_messages_to = array();

                if( $updates['ok'] ){

                    $count = count($updates['result']);

                    for( $i = $count - 1; $i >= 0; $i-- ){

                        $data = $updates['result'][$i];
                        $chat_id = $data['message']['chat']['id'];

                        if ( ( $chat_id < 0 && !isset($send_messages_to[$chat_id]) ) || ( isset($data['message']['text']) && strtolower($data['message']['text']) == $tg->password && !isset($send_messages_to[$chat_id]))){

                            $send_messages_to[$chat_id] = true;
                            
                            $db->setQuery("INSERT INTO #__breezingforms_addons_telegram_chats (form_id,chat_id) VALUES (".$db->quote($processor->form).", ".$db->quote($chat_id).") ON DUPLICATE KEY UPDATE chat_id=".$db->quote($chat_id));
                            $db->execute();

                        } else if ( ( isset($data['message']['text']) && strtolower($data['message']['text']) == 'stop' && !isset($send_messages_to[$chat_id]))){

                            // nothing for stopped ones
                            $send_messages_to[$chat_id] = true;
                            
                            $db->setQuery("Delete From #__breezingforms_addons_telegram_chats Where form_id = ".$db->quote($processor->form)." And chat_id = " . $db->quote($chat_id));
                            $db->execute();
                        }
                    }
                }
                
                $db->setQuery("Select chat_id From #__breezingforms_addons_telegram_chats Where form_id = ".$db->quote($processor->form));
                $_chat_ids = $db->loadColumn();
                
                if(function_exists('iconv') ){
                    $msg = $text = preg_replace_callback("/\\\\u([0-9a-fA-F]{4})/", function($m){
                        return iconv('UCS-4LE','UTF-8',pack('V', hexdec('U'.$m[0])));
                    }, $msg);
                }
                
                foreach($_chat_ids As $_chat_id){
                    
                    $telegram->sendChatAction($_chat_id, 'typing');
                    $telegram->sendMessage($_chat_id, "\xE2\x9C\x94 ".BFText::_('COM_BREEZINGFORMS_TG_NEW_RECORD')." \r\n\r\n");
                
                    
                    $telegram->sendChatAction($_chat_id, 'typing');

                    $telegram->sendMessage($_chat_id, $head.$msg, false, null, null, 'Markdown');

                    foreach( $uploads As $upload ){

                        $telegram->sendChatAction($_chat_id, 'typing');

                        $ex = explode('.',$upload);
                        $popped = array_pop($ex);
                        $ext = strtolower($popped);

                        switch($ext){
                            case 'png':
                            case 'jpg':
                            case 'jpeg':
                            case 'gif':
                                echo ($telegram->sendPhoto($_chat_id, $upload));
                                break;
                            case 'mp3':
                            case 'aif':
                            case 'iff':
                            case 'm3u':
                            case 'm4a':
                            case 'mid':
                            case 'mpa':
                            case 'wav':
                            case 'wma':
                                echo ($telegram->sendAudio($_chat_id, $upload));
                                break;
                            case '3g2':
                            case '3gp':
                            case 'asf':
                            case 'asx':
                            case 'avi':
                            case 'flv':
                            case 'm4v':
                            case 'mov':
                            case 'mp4':
                            case 'mpg':
                            case 'wmv':
                                echo ($telegram->sendVideo($_chat_id, $upload));
                                break;
                            default:
                                $telegram->sendDocument($_chat_id, $upload);
                        }
                    }

                    if( $tg->attach_pdf ){
                        $pdf = $processor->exppdf();
                        $telegram->sendChatAction($_chat_id, 'typing');
                        $telegram->sendDocument($_chat_id, $pdf);
                        JFile::delete($pdf);
                    }
                    
                    if( $tg->attach_csv ){
                        $csv = $processor->expcsv();
                        $telegram->sendChatAction($_chat_id, 'typing');
                        $telegram->sendDocument($_chat_id, $csv);
                        JFile::delete($csv);
                    }
                    
                    if( $tg->attach_xml ){
                        $xml = $processor->expxml();
                        $telegram->sendChatAction($_chat_id, 'typing');
                        $telegram->sendDocument($_chat_id, $xml);
                        JFile::delete($xml);
                    }
                    
                    $telegram->sendChatAction($_chat_id, 'typing');
                    $telegram->sendMessage($_chat_id, "\xE2\x9D\x8C ".BFText::_('COM_BREEZINGFORMS_TG_END_RECORD'));

                }
            
            }catch(Exception $e){
                // nothing, be silent

            }
        }
    }
}
